/**
 *  ____                                            
 * |  _ \ ___  ___  ___  _ __   __ _ _ __   ___ ___ 
 * | |_) / _ \/ __|/ _ \| '_ \ / _` | '_ \ / __/ _ \
 * |  _ <  __/\__ \ (_) | | | | (_| | | | | (_|  __/
 * |_| \_\___||___/\___/|_| |_|\__,_|_| |_|\___\___|
 * 
 * The Resonance App is developed by Michelle Rausch: https://gitlab.com/michelle.rausch
 * 
 * Resonance helps with voice-training, especially for transgender women.
 * What sets this app aside is the ability to display the resonance of the voice in addition to the pitch.
 * 
 * It is based on TarsosDSG by JorenSix: https://github.com/JorenSix/TarsosDSP
 * 
 * Resonance is licensed under GNU General Public License v3.0.
 */
package com.mooo.mrausch.resonance.backend.users;

import java.util.ArrayList;
import java.util.List;
import java.util.UUID;

/**
 * This class generates users for testing purposes
 * @author Michelle Rausch
 *
 */
public class UserFactory {

	/*
	 * Attributes
	 */
	/**
	 * The list of users generated by factory
	 */
	private List<User> randomUsers = new ArrayList<User>();
	
	/*
	 * Constructors
	 */
	/**
	 * default constructor,
	 * creates a single User
	 */
	public UserFactory() {
		
	}
	/**
	 * constructs factory with a specific number of users 
	 * @param howManyUsers
	 */
	public UserFactory(int howManyUsers) {
		createUsers(howManyUsers);
	}
	
	
	/**
	 * creates a single user and returns it
	 * @return the newly created User
	 */
	public User createAndReturnSingleUser() {
		User newUser = new User(UUID.randomUUID().toString());
		randomUsers.add(newUser);
		return newUser;
	}
	
	
	/**
	 * creates a specific number of users 
	 * @param howManyUsers
	 */
	public void createUsers(int howManyUsers) {
		for (int i = 0; i < howManyUsers; i++) {
			randomUsers.add(createAndReturnSingleUser());
		}
	}
	
	/**
	 * returns all users generated by this factory
	 * @return all users generated by this factory
	 */
	public List<User> getRandomUsers() {
		return randomUsers;
	}
	
	
	
	

}
